void * _cdecl operator new (size_t const Bytes);
void _cdecl operator delete (void * const Block);

bool IsEOS (wchar_t const c);
bool IsEOS (PCTSTR const p);
void SetEOS (PTSTR const p);

bool IsBlank (wchar_t const c);

PTSTR FindBlank (PTSTR const p);

inline PCTSTR FindBlank (PCTSTR const p) {
  return PCTSTR (FindBlank (PTSTR (p)));
}

PCTSTR SkipBlank (PCTSTR const p);

PCTSTR GetQuotedString (PCTSTR const p, PTSTR const String);

int CompareStrings (PCTSTR const S1, PCTSTR const S2, size_t const Len);

bool DelFile (PCTSTR const Path);

bool GetPreferredDevice (bool const Out, PTSTR const Buffer);
bool SetPreferredDevice (bool const Out, PCTSTR const Name);

HRESULT TranslateSetupApiError (void);

void FlushStorage ();

HDEVINFO CreateDL (GUID const * const ClassGuid, DWORD const Flags);
void DestroyDL (HDEVINFO & DL);

bool GetRegistrySzValue (HKEY const Key, PCTSTR const Name, PTSTR const Value, DWORD const Size);

HRESULT DeletePhantomValue (PCTSTR const InstanceId);

bool FindDeviceById (HDEVINFO const DL, SP_DEVINFO_DATA & DI, PCTSTR const HardwareId);

bool IsDevicePresent (PCTSTR const HardwareId);
bool GetDeviceStatus (PCTSTR const DevInstId, ULONG & Status, ULONG & Problem);
bool CheckIfRebootRequired (HDEVINFO const DL, SP_DEVINFO_DATA const & DI, bool & RebootRequired);

bool EnableDevice (HDEVINFO const DL, SP_DEVINFO_DATA const & DI, bool const Enable);

bool StopDeviceDriverWithRetry (
  HDEVINFO DL, SP_DEVINFO_DATA const & DI, PCTSTR const DevName, PCTSTR const ServiceId
);

bool RemoveDevice (HDEVINFO const DL, SP_DEVINFO_DATA & DI, PCTSTR const InstanceId);

SC_HANDLE OpenSystemService (PCTSTR const Name, UINT const SrvAccess, bool const MustExist = true);
bool GetServiceState (PCTSTR const Name, UINT & State);
bool WaitForServiceToStop (PCTSTR const Name, UINT const Sec);
bool RemoveService (PCTSTR const Name);
